(function () {
    "use strict";

    angular.module('core').controller('composicaoImpostoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$alert', 'lookupService', '$state', '$stateParams', 'composicaoImpostoService'];

    function controller($scope, $timeout, $q, $alert, lookupService, $state, $stateParams, composicaoImpostoService) {
        $scope.initializeLayout('Composição de Imposto');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: {
                Detalhes: 0,
                Impostos: 1,
            },
        };
        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            imposto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllImposto({ chaves: chaves })
                            .then(function (response) {

                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            operacaofiscal: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCodigoFiscalOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tipotributacaoicms: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllSituacaoTributaria({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            situacaoTributariaICMS: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllSituacaoTributaria({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            ClassificacaoTributariaIBSCBS: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllClassificacaoTributariaIBSCBS({ filtro: { Codigo: $scope.state.item.Alteracao.SituacaoTributariaIBSCBS.Codigo, ClassificacaoTributaria: chaves } })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            situacaoTributariaIBSCBS: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .GetAllSituacaoTributariaIBSCBS({ chaves: chaves, filtroEm: [{ Imposto: { Codigo: '1' } }, { Imposto: { Codigo: '44' } }] })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            situacaoTributaria: {
                lookup: function (chaves, imposto) {
                    return $q.when(
                        lookupService
                            .getAllSituacaoTributaria({ chaves: chaves, filtro: { Imposto: { Codigo: imposto } } })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            naturezaoperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllNaturezaOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoFiscalProduto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoFiscalEmpresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            estado: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEstado({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            origemtributo: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllOrigemTributo({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            produto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            getallcomposicao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoComposicaoImposto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.prepareNewItem = function () {
            composicaoImpostoService
                .prepareNewItemImposto($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.item = response.Data;
                        }
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    });
        }
        $scope.save = function () {
            $scope.state.carregando = true;
            composicaoImpostoService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.carregando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        },
            $scope.get = function () {
                $scope.state.carregando = true;
                $scope.state.vazio = false;
                composicaoImpostoService
                    .get($scope.state.item)
                    .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                                console.error(response.Exception);
                            } else {
                                $scope.state.item = response.Data;
                            }
                            $scope.state.carregando = false;
                            $scope.state.vazio = !$scope.state.item;
                        },
                        function (_error) {
                            $scope.state.carregando = false;
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            console.error(_error);
                        }
                    );
            };
        $scope.refresh = function () {
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();